/*
  tdump - Trivial hex dump - all output on 1 line!
  
  This file is part of the Linux lsvpd package.
  
  (C) Copyright IBM Corp. 2002, 2003, 2004
  
  Maintained by  Martin Schwenke <martins@au.ibm.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
 
  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
  $Id: tdump.c,v 1.7 2004/01/08 03:50:28 martins Exp $
*/
  
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

#include "util.h"

static void
usage()
{
	fprintf(stderr, "usage: %s [file]\n", vpd_program_name);
	exit(1);
}

int
main(int argc, char ** argv)
{
	char * data = NULL;
	size_t len;
	int    err;

	char * file = NULL;

	int ret = 0;

	vpd_program_name = argv[0];

	if (argc > 2)
		usage();

	if (argc == 2)
		file = argv[1];

	if (file_read_contents(file, &data, &len, &err)) {
		bool first = true;
		int i;
		for (i = 0; i < len; i++) {
			if (!first)
				printf(" ");
			printf("%.2x", (unsigned char) data[i]);
			first = false;
		}
		printf("\n");
		free(data);
	} else {
		die2(strerror(err), argv[1]);
	}

	return ret;
}
