#ifndef PCI_VPD_GEN_GRAB_H
#define PCI_VPD_GEN_GRAB_H

/*
  pci_vpd_gen_grab - Generic PCI VPD grabber.
  
  This file is part of the Linux lsvpd package.
  
  (C) Copyright IBM Corp. 2002, 2003, 2004
  
  Maintained by  Martin Schwenke <martins@au.ibm.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2, or (at your option)
  any later version.
 
  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  General Public License for more details.
 
  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
  
  $Id: pci_vpd_gen_grab.h,v 1.3 2004/01/08 03:58:07 martins Exp $
*/
  
#include <sys/types.h>
#include <stdint.h>

#include "growbuf.h"

struct vpd_state;

typedef ssize_t (*vpd_read_func) (struct vpd_state * this,
				  uint8_t          * c_ptr,
				  ssize_t            count);

struct vpd_state {
	vpd_read_func rf;
};

growbuf * grab_vpd(struct vpd_state *);

#endif
